#pragma once
// MESSAGE PAYLOAD_STATS_TM PACKING

#define MAVLINK_MSG_ID_PAYLOAD_STATS_TM 211


typedef struct __mavlink_payload_stats_tm_t {
 uint64_t liftoff_max_acc_ts; /*< [us] System clock at the maximum liftoff acceleration*/
 uint64_t dpl_ts; /*< [us] System clock at drouge deployment*/
 uint64_t max_z_speed_ts; /*< [us] System clock at max vertical speed*/
 uint64_t apogee_ts; /*< [us] System clock at apogee*/
 float liftoff_max_acc; /*< [m/s2] Maximum liftoff acceleration*/
 float dpl_max_acc; /*< [m/s2] Max acceleration during drouge deployment*/
 float max_z_speed; /*< [m/s] Max measured vertical speed*/
 float max_airspeed_pitot; /*< [m/s] Max speed read by the pitot tube*/
 float max_speed_altitude; /*< [m] Altitude at max speed*/
 float apogee_lat; /*< [deg] Apogee latitude*/
 float apogee_lon; /*< [deg] Apogee longitude*/
 float apogee_alt; /*< [m] Apogee altitude*/
 float min_pressure; /*< [Pa] Apogee pressure - Digital barometer*/
 float cpu_load; /*<  CPU load in percentage*/
 uint32_t free_heap; /*<  Amount of available heap in memory*/
 int32_t log_good; /*<  0 if log failed, 1 otherwise*/
 int16_t log_number; /*<  Currently active log file, -1 if the logger is inactive*/
 uint8_t main_board_state; /*<  Main board fmm state*/
 uint8_t motor_board_state; /*<  Motor board fmm state*/
 uint8_t main_can_status; /*<  Main CAN status*/
 uint8_t motor_can_status; /*<  Motor CAN status*/
 uint8_t rig_can_status; /*<  RIG CAN status*/
 uint8_t hil_state; /*<  1 if the board is currently in HIL mode*/
} mavlink_payload_stats_tm_t;

#define MAVLINK_MSG_ID_PAYLOAD_STATS_TM_LEN 88
#define MAVLINK_MSG_ID_PAYLOAD_STATS_TM_MIN_LEN 88
#define MAVLINK_MSG_ID_211_LEN 88
#define MAVLINK_MSG_ID_211_MIN_LEN 88

#define MAVLINK_MSG_ID_PAYLOAD_STATS_TM_CRC 64
#define MAVLINK_MSG_ID_211_CRC 64



#if MAVLINK_COMMAND_24BIT
#define MAVLINK_MESSAGE_INFO_PAYLOAD_STATS_TM { \
    211, \
    "PAYLOAD_STATS_TM", \
    23, \
    {  { "liftoff_max_acc_ts", NULL, MAVLINK_TYPE_UINT64_T, 0, 0, offsetof(mavlink_payload_stats_tm_t, liftoff_max_acc_ts) }, \
         { "liftoff_max_acc", NULL, MAVLINK_TYPE_FLOAT, 0, 32, offsetof(mavlink_payload_stats_tm_t, liftoff_max_acc) }, \
         { "dpl_ts", NULL, MAVLINK_TYPE_UINT64_T, 0, 8, offsetof(mavlink_payload_stats_tm_t, dpl_ts) }, \
         { "dpl_max_acc", NULL, MAVLINK_TYPE_FLOAT, 0, 36, offsetof(mavlink_payload_stats_tm_t, dpl_max_acc) }, \
         { "max_z_speed_ts", NULL, MAVLINK_TYPE_UINT64_T, 0, 16, offsetof(mavlink_payload_stats_tm_t, max_z_speed_ts) }, \
         { "max_z_speed", NULL, MAVLINK_TYPE_FLOAT, 0, 40, offsetof(mavlink_payload_stats_tm_t, max_z_speed) }, \
         { "max_airspeed_pitot", NULL, MAVLINK_TYPE_FLOAT, 0, 44, offsetof(mavlink_payload_stats_tm_t, max_airspeed_pitot) }, \
         { "max_speed_altitude", NULL, MAVLINK_TYPE_FLOAT, 0, 48, offsetof(mavlink_payload_stats_tm_t, max_speed_altitude) }, \
         { "apogee_ts", NULL, MAVLINK_TYPE_UINT64_T, 0, 24, offsetof(mavlink_payload_stats_tm_t, apogee_ts) }, \
         { "apogee_lat", NULL, MAVLINK_TYPE_FLOAT, 0, 52, offsetof(mavlink_payload_stats_tm_t, apogee_lat) }, \
         { "apogee_lon", NULL, MAVLINK_TYPE_FLOAT, 0, 56, offsetof(mavlink_payload_stats_tm_t, apogee_lon) }, \
         { "apogee_alt", NULL, MAVLINK_TYPE_FLOAT, 0, 60, offsetof(mavlink_payload_stats_tm_t, apogee_alt) }, \
         { "min_pressure", NULL, MAVLINK_TYPE_FLOAT, 0, 64, offsetof(mavlink_payload_stats_tm_t, min_pressure) }, \
         { "cpu_load", NULL, MAVLINK_TYPE_FLOAT, 0, 68, offsetof(mavlink_payload_stats_tm_t, cpu_load) }, \
         { "free_heap", NULL, MAVLINK_TYPE_UINT32_T, 0, 72, offsetof(mavlink_payload_stats_tm_t, free_heap) }, \
         { "log_number", NULL, MAVLINK_TYPE_INT16_T, 0, 80, offsetof(mavlink_payload_stats_tm_t, log_number) }, \
         { "log_good", NULL, MAVLINK_TYPE_INT32_T, 0, 76, offsetof(mavlink_payload_stats_tm_t, log_good) }, \
         { "main_board_state", NULL, MAVLINK_TYPE_UINT8_T, 0, 82, offsetof(mavlink_payload_stats_tm_t, main_board_state) }, \
         { "motor_board_state", NULL, MAVLINK_TYPE_UINT8_T, 0, 83, offsetof(mavlink_payload_stats_tm_t, motor_board_state) }, \
         { "main_can_status", NULL, MAVLINK_TYPE_UINT8_T, 0, 84, offsetof(mavlink_payload_stats_tm_t, main_can_status) }, \
         { "motor_can_status", NULL, MAVLINK_TYPE_UINT8_T, 0, 85, offsetof(mavlink_payload_stats_tm_t, motor_can_status) }, \
         { "rig_can_status", NULL, MAVLINK_TYPE_UINT8_T, 0, 86, offsetof(mavlink_payload_stats_tm_t, rig_can_status) }, \
         { "hil_state", NULL, MAVLINK_TYPE_UINT8_T, 0, 87, offsetof(mavlink_payload_stats_tm_t, hil_state) }, \
         } \
}
#else
#define MAVLINK_MESSAGE_INFO_PAYLOAD_STATS_TM { \
    "PAYLOAD_STATS_TM", \
    23, \
    {  { "liftoff_max_acc_ts", NULL, MAVLINK_TYPE_UINT64_T, 0, 0, offsetof(mavlink_payload_stats_tm_t, liftoff_max_acc_ts) }, \
         { "liftoff_max_acc", NULL, MAVLINK_TYPE_FLOAT, 0, 32, offsetof(mavlink_payload_stats_tm_t, liftoff_max_acc) }, \
         { "dpl_ts", NULL, MAVLINK_TYPE_UINT64_T, 0, 8, offsetof(mavlink_payload_stats_tm_t, dpl_ts) }, \
         { "dpl_max_acc", NULL, MAVLINK_TYPE_FLOAT, 0, 36, offsetof(mavlink_payload_stats_tm_t, dpl_max_acc) }, \
         { "max_z_speed_ts", NULL, MAVLINK_TYPE_UINT64_T, 0, 16, offsetof(mavlink_payload_stats_tm_t, max_z_speed_ts) }, \
         { "max_z_speed", NULL, MAVLINK_TYPE_FLOAT, 0, 40, offsetof(mavlink_payload_stats_tm_t, max_z_speed) }, \
         { "max_airspeed_pitot", NULL, MAVLINK_TYPE_FLOAT, 0, 44, offsetof(mavlink_payload_stats_tm_t, max_airspeed_pitot) }, \
         { "max_speed_altitude", NULL, MAVLINK_TYPE_FLOAT, 0, 48, offsetof(mavlink_payload_stats_tm_t, max_speed_altitude) }, \
         { "apogee_ts", NULL, MAVLINK_TYPE_UINT64_T, 0, 24, offsetof(mavlink_payload_stats_tm_t, apogee_ts) }, \
         { "apogee_lat", NULL, MAVLINK_TYPE_FLOAT, 0, 52, offsetof(mavlink_payload_stats_tm_t, apogee_lat) }, \
         { "apogee_lon", NULL, MAVLINK_TYPE_FLOAT, 0, 56, offsetof(mavlink_payload_stats_tm_t, apogee_lon) }, \
         { "apogee_alt", NULL, MAVLINK_TYPE_FLOAT, 0, 60, offsetof(mavlink_payload_stats_tm_t, apogee_alt) }, \
         { "min_pressure", NULL, MAVLINK_TYPE_FLOAT, 0, 64, offsetof(mavlink_payload_stats_tm_t, min_pressure) }, \
         { "cpu_load", NULL, MAVLINK_TYPE_FLOAT, 0, 68, offsetof(mavlink_payload_stats_tm_t, cpu_load) }, \
         { "free_heap", NULL, MAVLINK_TYPE_UINT32_T, 0, 72, offsetof(mavlink_payload_stats_tm_t, free_heap) }, \
         { "log_number", NULL, MAVLINK_TYPE_INT16_T, 0, 80, offsetof(mavlink_payload_stats_tm_t, log_number) }, \
         { "log_good", NULL, MAVLINK_TYPE_INT32_T, 0, 76, offsetof(mavlink_payload_stats_tm_t, log_good) }, \
         { "main_board_state", NULL, MAVLINK_TYPE_UINT8_T, 0, 82, offsetof(mavlink_payload_stats_tm_t, main_board_state) }, \
         { "motor_board_state", NULL, MAVLINK_TYPE_UINT8_T, 0, 83, offsetof(mavlink_payload_stats_tm_t, motor_board_state) }, \
         { "main_can_status", NULL, MAVLINK_TYPE_UINT8_T, 0, 84, offsetof(mavlink_payload_stats_tm_t, main_can_status) }, \
         { "motor_can_status", NULL, MAVLINK_TYPE_UINT8_T, 0, 85, offsetof(mavlink_payload_stats_tm_t, motor_can_status) }, \
         { "rig_can_status", NULL, MAVLINK_TYPE_UINT8_T, 0, 86, offsetof(mavlink_payload_stats_tm_t, rig_can_status) }, \
         { "hil_state", NULL, MAVLINK_TYPE_UINT8_T, 0, 87, offsetof(mavlink_payload_stats_tm_t, hil_state) }, \
         } \
}
#endif

/**
 * @brief Pack a payload_stats_tm message
 * @param system_id ID of this system
 * @param component_id ID of this component (e.g. 200 for IMU)
 * @param msg The MAVLink message to compress the data into
 *
 * @param liftoff_max_acc_ts [us] System clock at the maximum liftoff acceleration
 * @param liftoff_max_acc [m/s2] Maximum liftoff acceleration
 * @param dpl_ts [us] System clock at drouge deployment
 * @param dpl_max_acc [m/s2] Max acceleration during drouge deployment
 * @param max_z_speed_ts [us] System clock at max vertical speed
 * @param max_z_speed [m/s] Max measured vertical speed
 * @param max_airspeed_pitot [m/s] Max speed read by the pitot tube
 * @param max_speed_altitude [m] Altitude at max speed
 * @param apogee_ts [us] System clock at apogee
 * @param apogee_lat [deg] Apogee latitude
 * @param apogee_lon [deg] Apogee longitude
 * @param apogee_alt [m] Apogee altitude
 * @param min_pressure [Pa] Apogee pressure - Digital barometer
 * @param cpu_load  CPU load in percentage
 * @param free_heap  Amount of available heap in memory
 * @param log_number  Currently active log file, -1 if the logger is inactive
 * @param log_good  0 if log failed, 1 otherwise
 * @param main_board_state  Main board fmm state
 * @param motor_board_state  Motor board fmm state
 * @param main_can_status  Main CAN status
 * @param motor_can_status  Motor CAN status
 * @param rig_can_status  RIG CAN status
 * @param hil_state  1 if the board is currently in HIL mode
 * @return length of the message in bytes (excluding serial stream start sign)
 */
static inline uint16_t mavlink_msg_payload_stats_tm_pack(uint8_t system_id, uint8_t component_id, mavlink_message_t* msg,
                               uint64_t liftoff_max_acc_ts, float liftoff_max_acc, uint64_t dpl_ts, float dpl_max_acc, uint64_t max_z_speed_ts, float max_z_speed, float max_airspeed_pitot, float max_speed_altitude, uint64_t apogee_ts, float apogee_lat, float apogee_lon, float apogee_alt, float min_pressure, float cpu_load, uint32_t free_heap, int16_t log_number, int32_t log_good, uint8_t main_board_state, uint8_t motor_board_state, uint8_t main_can_status, uint8_t motor_can_status, uint8_t rig_can_status, uint8_t hil_state)
{
#if MAVLINK_NEED_BYTE_SWAP || !MAVLINK_ALIGNED_FIELDS
    char buf[MAVLINK_MSG_ID_PAYLOAD_STATS_TM_LEN];
    _mav_put_uint64_t(buf, 0, liftoff_max_acc_ts);
    _mav_put_uint64_t(buf, 8, dpl_ts);
    _mav_put_uint64_t(buf, 16, max_z_speed_ts);
    _mav_put_uint64_t(buf, 24, apogee_ts);
    _mav_put_float(buf, 32, liftoff_max_acc);
    _mav_put_float(buf, 36, dpl_max_acc);
    _mav_put_float(buf, 40, max_z_speed);
    _mav_put_float(buf, 44, max_airspeed_pitot);
    _mav_put_float(buf, 48, max_speed_altitude);
    _mav_put_float(buf, 52, apogee_lat);
    _mav_put_float(buf, 56, apogee_lon);
    _mav_put_float(buf, 60, apogee_alt);
    _mav_put_float(buf, 64, min_pressure);
    _mav_put_float(buf, 68, cpu_load);
    _mav_put_uint32_t(buf, 72, free_heap);
    _mav_put_int32_t(buf, 76, log_good);
    _mav_put_int16_t(buf, 80, log_number);
    _mav_put_uint8_t(buf, 82, main_board_state);
    _mav_put_uint8_t(buf, 83, motor_board_state);
    _mav_put_uint8_t(buf, 84, main_can_status);
    _mav_put_uint8_t(buf, 85, motor_can_status);
    _mav_put_uint8_t(buf, 86, rig_can_status);
    _mav_put_uint8_t(buf, 87, hil_state);

        memcpy(_MAV_PAYLOAD_NON_CONST(msg), buf, MAVLINK_MSG_ID_PAYLOAD_STATS_TM_LEN);
#else
    mavlink_payload_stats_tm_t packet;
    packet.liftoff_max_acc_ts = liftoff_max_acc_ts;
    packet.dpl_ts = dpl_ts;
    packet.max_z_speed_ts = max_z_speed_ts;
    packet.apogee_ts = apogee_ts;
    packet.liftoff_max_acc = liftoff_max_acc;
    packet.dpl_max_acc = dpl_max_acc;
    packet.max_z_speed = max_z_speed;
    packet.max_airspeed_pitot = max_airspeed_pitot;
    packet.max_speed_altitude = max_speed_altitude;
    packet.apogee_lat = apogee_lat;
    packet.apogee_lon = apogee_lon;
    packet.apogee_alt = apogee_alt;
    packet.min_pressure = min_pressure;
    packet.cpu_load = cpu_load;
    packet.free_heap = free_heap;
    packet.log_good = log_good;
    packet.log_number = log_number;
    packet.main_board_state = main_board_state;
    packet.motor_board_state = motor_board_state;
    packet.main_can_status = main_can_status;
    packet.motor_can_status = motor_can_status;
    packet.rig_can_status = rig_can_status;
    packet.hil_state = hil_state;

        memcpy(_MAV_PAYLOAD_NON_CONST(msg), &packet, MAVLINK_MSG_ID_PAYLOAD_STATS_TM_LEN);
#endif

    msg->msgid = MAVLINK_MSG_ID_PAYLOAD_STATS_TM;
    return mavlink_finalize_message(msg, system_id, component_id, MAVLINK_MSG_ID_PAYLOAD_STATS_TM_MIN_LEN, MAVLINK_MSG_ID_PAYLOAD_STATS_TM_LEN, MAVLINK_MSG_ID_PAYLOAD_STATS_TM_CRC);
}

/**
 * @brief Pack a payload_stats_tm message on a channel
 * @param system_id ID of this system
 * @param component_id ID of this component (e.g. 200 for IMU)
 * @param chan The MAVLink channel this message will be sent over
 * @param msg The MAVLink message to compress the data into
 * @param liftoff_max_acc_ts [us] System clock at the maximum liftoff acceleration
 * @param liftoff_max_acc [m/s2] Maximum liftoff acceleration
 * @param dpl_ts [us] System clock at drouge deployment
 * @param dpl_max_acc [m/s2] Max acceleration during drouge deployment
 * @param max_z_speed_ts [us] System clock at max vertical speed
 * @param max_z_speed [m/s] Max measured vertical speed
 * @param max_airspeed_pitot [m/s] Max speed read by the pitot tube
 * @param max_speed_altitude [m] Altitude at max speed
 * @param apogee_ts [us] System clock at apogee
 * @param apogee_lat [deg] Apogee latitude
 * @param apogee_lon [deg] Apogee longitude
 * @param apogee_alt [m] Apogee altitude
 * @param min_pressure [Pa] Apogee pressure - Digital barometer
 * @param cpu_load  CPU load in percentage
 * @param free_heap  Amount of available heap in memory
 * @param log_number  Currently active log file, -1 if the logger is inactive
 * @param log_good  0 if log failed, 1 otherwise
 * @param main_board_state  Main board fmm state
 * @param motor_board_state  Motor board fmm state
 * @param main_can_status  Main CAN status
 * @param motor_can_status  Motor CAN status
 * @param rig_can_status  RIG CAN status
 * @param hil_state  1 if the board is currently in HIL mode
 * @return length of the message in bytes (excluding serial stream start sign)
 */
static inline uint16_t mavlink_msg_payload_stats_tm_pack_chan(uint8_t system_id, uint8_t component_id, uint8_t chan,
                               mavlink_message_t* msg,
                                   uint64_t liftoff_max_acc_ts,float liftoff_max_acc,uint64_t dpl_ts,float dpl_max_acc,uint64_t max_z_speed_ts,float max_z_speed,float max_airspeed_pitot,float max_speed_altitude,uint64_t apogee_ts,float apogee_lat,float apogee_lon,float apogee_alt,float min_pressure,float cpu_load,uint32_t free_heap,int16_t log_number,int32_t log_good,uint8_t main_board_state,uint8_t motor_board_state,uint8_t main_can_status,uint8_t motor_can_status,uint8_t rig_can_status,uint8_t hil_state)
{
#if MAVLINK_NEED_BYTE_SWAP || !MAVLINK_ALIGNED_FIELDS
    char buf[MAVLINK_MSG_ID_PAYLOAD_STATS_TM_LEN];
    _mav_put_uint64_t(buf, 0, liftoff_max_acc_ts);
    _mav_put_uint64_t(buf, 8, dpl_ts);
    _mav_put_uint64_t(buf, 16, max_z_speed_ts);
    _mav_put_uint64_t(buf, 24, apogee_ts);
    _mav_put_float(buf, 32, liftoff_max_acc);
    _mav_put_float(buf, 36, dpl_max_acc);
    _mav_put_float(buf, 40, max_z_speed);
    _mav_put_float(buf, 44, max_airspeed_pitot);
    _mav_put_float(buf, 48, max_speed_altitude);
    _mav_put_float(buf, 52, apogee_lat);
    _mav_put_float(buf, 56, apogee_lon);
    _mav_put_float(buf, 60, apogee_alt);
    _mav_put_float(buf, 64, min_pressure);
    _mav_put_float(buf, 68, cpu_load);
    _mav_put_uint32_t(buf, 72, free_heap);
    _mav_put_int32_t(buf, 76, log_good);
    _mav_put_int16_t(buf, 80, log_number);
    _mav_put_uint8_t(buf, 82, main_board_state);
    _mav_put_uint8_t(buf, 83, motor_board_state);
    _mav_put_uint8_t(buf, 84, main_can_status);
    _mav_put_uint8_t(buf, 85, motor_can_status);
    _mav_put_uint8_t(buf, 86, rig_can_status);
    _mav_put_uint8_t(buf, 87, hil_state);

        memcpy(_MAV_PAYLOAD_NON_CONST(msg), buf, MAVLINK_MSG_ID_PAYLOAD_STATS_TM_LEN);
#else
    mavlink_payload_stats_tm_t packet;
    packet.liftoff_max_acc_ts = liftoff_max_acc_ts;
    packet.dpl_ts = dpl_ts;
    packet.max_z_speed_ts = max_z_speed_ts;
    packet.apogee_ts = apogee_ts;
    packet.liftoff_max_acc = liftoff_max_acc;
    packet.dpl_max_acc = dpl_max_acc;
    packet.max_z_speed = max_z_speed;
    packet.max_airspeed_pitot = max_airspeed_pitot;
    packet.max_speed_altitude = max_speed_altitude;
    packet.apogee_lat = apogee_lat;
    packet.apogee_lon = apogee_lon;
    packet.apogee_alt = apogee_alt;
    packet.min_pressure = min_pressure;
    packet.cpu_load = cpu_load;
    packet.free_heap = free_heap;
    packet.log_good = log_good;
    packet.log_number = log_number;
    packet.main_board_state = main_board_state;
    packet.motor_board_state = motor_board_state;
    packet.main_can_status = main_can_status;
    packet.motor_can_status = motor_can_status;
    packet.rig_can_status = rig_can_status;
    packet.hil_state = hil_state;

        memcpy(_MAV_PAYLOAD_NON_CONST(msg), &packet, MAVLINK_MSG_ID_PAYLOAD_STATS_TM_LEN);
#endif

    msg->msgid = MAVLINK_MSG_ID_PAYLOAD_STATS_TM;
    return mavlink_finalize_message_chan(msg, system_id, component_id, chan, MAVLINK_MSG_ID_PAYLOAD_STATS_TM_MIN_LEN, MAVLINK_MSG_ID_PAYLOAD_STATS_TM_LEN, MAVLINK_MSG_ID_PAYLOAD_STATS_TM_CRC);
}

/**
 * @brief Encode a payload_stats_tm struct
 *
 * @param system_id ID of this system
 * @param component_id ID of this component (e.g. 200 for IMU)
 * @param msg The MAVLink message to compress the data into
 * @param payload_stats_tm C-struct to read the message contents from
 */
static inline uint16_t mavlink_msg_payload_stats_tm_encode(uint8_t system_id, uint8_t component_id, mavlink_message_t* msg, const mavlink_payload_stats_tm_t* payload_stats_tm)
{
    return mavlink_msg_payload_stats_tm_pack(system_id, component_id, msg, payload_stats_tm->liftoff_max_acc_ts, payload_stats_tm->liftoff_max_acc, payload_stats_tm->dpl_ts, payload_stats_tm->dpl_max_acc, payload_stats_tm->max_z_speed_ts, payload_stats_tm->max_z_speed, payload_stats_tm->max_airspeed_pitot, payload_stats_tm->max_speed_altitude, payload_stats_tm->apogee_ts, payload_stats_tm->apogee_lat, payload_stats_tm->apogee_lon, payload_stats_tm->apogee_alt, payload_stats_tm->min_pressure, payload_stats_tm->cpu_load, payload_stats_tm->free_heap, payload_stats_tm->log_number, payload_stats_tm->log_good, payload_stats_tm->main_board_state, payload_stats_tm->motor_board_state, payload_stats_tm->main_can_status, payload_stats_tm->motor_can_status, payload_stats_tm->rig_can_status, payload_stats_tm->hil_state);
}

/**
 * @brief Encode a payload_stats_tm struct on a channel
 *
 * @param system_id ID of this system
 * @param component_id ID of this component (e.g. 200 for IMU)
 * @param chan The MAVLink channel this message will be sent over
 * @param msg The MAVLink message to compress the data into
 * @param payload_stats_tm C-struct to read the message contents from
 */
static inline uint16_t mavlink_msg_payload_stats_tm_encode_chan(uint8_t system_id, uint8_t component_id, uint8_t chan, mavlink_message_t* msg, const mavlink_payload_stats_tm_t* payload_stats_tm)
{
    return mavlink_msg_payload_stats_tm_pack_chan(system_id, component_id, chan, msg, payload_stats_tm->liftoff_max_acc_ts, payload_stats_tm->liftoff_max_acc, payload_stats_tm->dpl_ts, payload_stats_tm->dpl_max_acc, payload_stats_tm->max_z_speed_ts, payload_stats_tm->max_z_speed, payload_stats_tm->max_airspeed_pitot, payload_stats_tm->max_speed_altitude, payload_stats_tm->apogee_ts, payload_stats_tm->apogee_lat, payload_stats_tm->apogee_lon, payload_stats_tm->apogee_alt, payload_stats_tm->min_pressure, payload_stats_tm->cpu_load, payload_stats_tm->free_heap, payload_stats_tm->log_number, payload_stats_tm->log_good, payload_stats_tm->main_board_state, payload_stats_tm->motor_board_state, payload_stats_tm->main_can_status, payload_stats_tm->motor_can_status, payload_stats_tm->rig_can_status, payload_stats_tm->hil_state);
}

/**
 * @brief Send a payload_stats_tm message
 * @param chan MAVLink channel to send the message
 *
 * @param liftoff_max_acc_ts [us] System clock at the maximum liftoff acceleration
 * @param liftoff_max_acc [m/s2] Maximum liftoff acceleration
 * @param dpl_ts [us] System clock at drouge deployment
 * @param dpl_max_acc [m/s2] Max acceleration during drouge deployment
 * @param max_z_speed_ts [us] System clock at max vertical speed
 * @param max_z_speed [m/s] Max measured vertical speed
 * @param max_airspeed_pitot [m/s] Max speed read by the pitot tube
 * @param max_speed_altitude [m] Altitude at max speed
 * @param apogee_ts [us] System clock at apogee
 * @param apogee_lat [deg] Apogee latitude
 * @param apogee_lon [deg] Apogee longitude
 * @param apogee_alt [m] Apogee altitude
 * @param min_pressure [Pa] Apogee pressure - Digital barometer
 * @param cpu_load  CPU load in percentage
 * @param free_heap  Amount of available heap in memory
 * @param log_number  Currently active log file, -1 if the logger is inactive
 * @param log_good  0 if log failed, 1 otherwise
 * @param main_board_state  Main board fmm state
 * @param motor_board_state  Motor board fmm state
 * @param main_can_status  Main CAN status
 * @param motor_can_status  Motor CAN status
 * @param rig_can_status  RIG CAN status
 * @param hil_state  1 if the board is currently in HIL mode
 */
#ifdef MAVLINK_USE_CONVENIENCE_FUNCTIONS

static inline void mavlink_msg_payload_stats_tm_send(mavlink_channel_t chan, uint64_t liftoff_max_acc_ts, float liftoff_max_acc, uint64_t dpl_ts, float dpl_max_acc, uint64_t max_z_speed_ts, float max_z_speed, float max_airspeed_pitot, float max_speed_altitude, uint64_t apogee_ts, float apogee_lat, float apogee_lon, float apogee_alt, float min_pressure, float cpu_load, uint32_t free_heap, int16_t log_number, int32_t log_good, uint8_t main_board_state, uint8_t motor_board_state, uint8_t main_can_status, uint8_t motor_can_status, uint8_t rig_can_status, uint8_t hil_state)
{
#if MAVLINK_NEED_BYTE_SWAP || !MAVLINK_ALIGNED_FIELDS
    char buf[MAVLINK_MSG_ID_PAYLOAD_STATS_TM_LEN];
    _mav_put_uint64_t(buf, 0, liftoff_max_acc_ts);
    _mav_put_uint64_t(buf, 8, dpl_ts);
    _mav_put_uint64_t(buf, 16, max_z_speed_ts);
    _mav_put_uint64_t(buf, 24, apogee_ts);
    _mav_put_float(buf, 32, liftoff_max_acc);
    _mav_put_float(buf, 36, dpl_max_acc);
    _mav_put_float(buf, 40, max_z_speed);
    _mav_put_float(buf, 44, max_airspeed_pitot);
    _mav_put_float(buf, 48, max_speed_altitude);
    _mav_put_float(buf, 52, apogee_lat);
    _mav_put_float(buf, 56, apogee_lon);
    _mav_put_float(buf, 60, apogee_alt);
    _mav_put_float(buf, 64, min_pressure);
    _mav_put_float(buf, 68, cpu_load);
    _mav_put_uint32_t(buf, 72, free_heap);
    _mav_put_int32_t(buf, 76, log_good);
    _mav_put_int16_t(buf, 80, log_number);
    _mav_put_uint8_t(buf, 82, main_board_state);
    _mav_put_uint8_t(buf, 83, motor_board_state);
    _mav_put_uint8_t(buf, 84, main_can_status);
    _mav_put_uint8_t(buf, 85, motor_can_status);
    _mav_put_uint8_t(buf, 86, rig_can_status);
    _mav_put_uint8_t(buf, 87, hil_state);

    _mav_finalize_message_chan_send(chan, MAVLINK_MSG_ID_PAYLOAD_STATS_TM, buf, MAVLINK_MSG_ID_PAYLOAD_STATS_TM_MIN_LEN, MAVLINK_MSG_ID_PAYLOAD_STATS_TM_LEN, MAVLINK_MSG_ID_PAYLOAD_STATS_TM_CRC);
#else
    mavlink_payload_stats_tm_t packet;
    packet.liftoff_max_acc_ts = liftoff_max_acc_ts;
    packet.dpl_ts = dpl_ts;
    packet.max_z_speed_ts = max_z_speed_ts;
    packet.apogee_ts = apogee_ts;
    packet.liftoff_max_acc = liftoff_max_acc;
    packet.dpl_max_acc = dpl_max_acc;
    packet.max_z_speed = max_z_speed;
    packet.max_airspeed_pitot = max_airspeed_pitot;
    packet.max_speed_altitude = max_speed_altitude;
    packet.apogee_lat = apogee_lat;
    packet.apogee_lon = apogee_lon;
    packet.apogee_alt = apogee_alt;
    packet.min_pressure = min_pressure;
    packet.cpu_load = cpu_load;
    packet.free_heap = free_heap;
    packet.log_good = log_good;
    packet.log_number = log_number;
    packet.main_board_state = main_board_state;
    packet.motor_board_state = motor_board_state;
    packet.main_can_status = main_can_status;
    packet.motor_can_status = motor_can_status;
    packet.rig_can_status = rig_can_status;
    packet.hil_state = hil_state;

    _mav_finalize_message_chan_send(chan, MAVLINK_MSG_ID_PAYLOAD_STATS_TM, (const char *)&packet, MAVLINK_MSG_ID_PAYLOAD_STATS_TM_MIN_LEN, MAVLINK_MSG_ID_PAYLOAD_STATS_TM_LEN, MAVLINK_MSG_ID_PAYLOAD_STATS_TM_CRC);
#endif
}

/**
 * @brief Send a payload_stats_tm message
 * @param chan MAVLink channel to send the message
 * @param struct The MAVLink struct to serialize
 */
static inline void mavlink_msg_payload_stats_tm_send_struct(mavlink_channel_t chan, const mavlink_payload_stats_tm_t* payload_stats_tm)
{
#if MAVLINK_NEED_BYTE_SWAP || !MAVLINK_ALIGNED_FIELDS
    mavlink_msg_payload_stats_tm_send(chan, payload_stats_tm->liftoff_max_acc_ts, payload_stats_tm->liftoff_max_acc, payload_stats_tm->dpl_ts, payload_stats_tm->dpl_max_acc, payload_stats_tm->max_z_speed_ts, payload_stats_tm->max_z_speed, payload_stats_tm->max_airspeed_pitot, payload_stats_tm->max_speed_altitude, payload_stats_tm->apogee_ts, payload_stats_tm->apogee_lat, payload_stats_tm->apogee_lon, payload_stats_tm->apogee_alt, payload_stats_tm->min_pressure, payload_stats_tm->cpu_load, payload_stats_tm->free_heap, payload_stats_tm->log_number, payload_stats_tm->log_good, payload_stats_tm->main_board_state, payload_stats_tm->motor_board_state, payload_stats_tm->main_can_status, payload_stats_tm->motor_can_status, payload_stats_tm->rig_can_status, payload_stats_tm->hil_state);
#else
    _mav_finalize_message_chan_send(chan, MAVLINK_MSG_ID_PAYLOAD_STATS_TM, (const char *)payload_stats_tm, MAVLINK_MSG_ID_PAYLOAD_STATS_TM_MIN_LEN, MAVLINK_MSG_ID_PAYLOAD_STATS_TM_LEN, MAVLINK_MSG_ID_PAYLOAD_STATS_TM_CRC);
#endif
}

#if MAVLINK_MSG_ID_PAYLOAD_STATS_TM_LEN <= MAVLINK_MAX_PAYLOAD_LEN
/*
  This variant of _send() can be used to save stack space by re-using
  memory from the receive buffer.  The caller provides a
  mavlink_message_t which is the size of a full mavlink message. This
  is usually the receive buffer for the channel, and allows a reply to an
  incoming message with minimum stack space usage.
 */
static inline void mavlink_msg_payload_stats_tm_send_buf(mavlink_message_t *msgbuf, mavlink_channel_t chan,  uint64_t liftoff_max_acc_ts, float liftoff_max_acc, uint64_t dpl_ts, float dpl_max_acc, uint64_t max_z_speed_ts, float max_z_speed, float max_airspeed_pitot, float max_speed_altitude, uint64_t apogee_ts, float apogee_lat, float apogee_lon, float apogee_alt, float min_pressure, float cpu_load, uint32_t free_heap, int16_t log_number, int32_t log_good, uint8_t main_board_state, uint8_t motor_board_state, uint8_t main_can_status, uint8_t motor_can_status, uint8_t rig_can_status, uint8_t hil_state)
{
#if MAVLINK_NEED_BYTE_SWAP || !MAVLINK_ALIGNED_FIELDS
    char *buf = (char *)msgbuf;
    _mav_put_uint64_t(buf, 0, liftoff_max_acc_ts);
    _mav_put_uint64_t(buf, 8, dpl_ts);
    _mav_put_uint64_t(buf, 16, max_z_speed_ts);
    _mav_put_uint64_t(buf, 24, apogee_ts);
    _mav_put_float(buf, 32, liftoff_max_acc);
    _mav_put_float(buf, 36, dpl_max_acc);
    _mav_put_float(buf, 40, max_z_speed);
    _mav_put_float(buf, 44, max_airspeed_pitot);
    _mav_put_float(buf, 48, max_speed_altitude);
    _mav_put_float(buf, 52, apogee_lat);
    _mav_put_float(buf, 56, apogee_lon);
    _mav_put_float(buf, 60, apogee_alt);
    _mav_put_float(buf, 64, min_pressure);
    _mav_put_float(buf, 68, cpu_load);
    _mav_put_uint32_t(buf, 72, free_heap);
    _mav_put_int32_t(buf, 76, log_good);
    _mav_put_int16_t(buf, 80, log_number);
    _mav_put_uint8_t(buf, 82, main_board_state);
    _mav_put_uint8_t(buf, 83, motor_board_state);
    _mav_put_uint8_t(buf, 84, main_can_status);
    _mav_put_uint8_t(buf, 85, motor_can_status);
    _mav_put_uint8_t(buf, 86, rig_can_status);
    _mav_put_uint8_t(buf, 87, hil_state);

    _mav_finalize_message_chan_send(chan, MAVLINK_MSG_ID_PAYLOAD_STATS_TM, buf, MAVLINK_MSG_ID_PAYLOAD_STATS_TM_MIN_LEN, MAVLINK_MSG_ID_PAYLOAD_STATS_TM_LEN, MAVLINK_MSG_ID_PAYLOAD_STATS_TM_CRC);
#else
    mavlink_payload_stats_tm_t *packet = (mavlink_payload_stats_tm_t *)msgbuf;
    packet->liftoff_max_acc_ts = liftoff_max_acc_ts;
    packet->dpl_ts = dpl_ts;
    packet->max_z_speed_ts = max_z_speed_ts;
    packet->apogee_ts = apogee_ts;
    packet->liftoff_max_acc = liftoff_max_acc;
    packet->dpl_max_acc = dpl_max_acc;
    packet->max_z_speed = max_z_speed;
    packet->max_airspeed_pitot = max_airspeed_pitot;
    packet->max_speed_altitude = max_speed_altitude;
    packet->apogee_lat = apogee_lat;
    packet->apogee_lon = apogee_lon;
    packet->apogee_alt = apogee_alt;
    packet->min_pressure = min_pressure;
    packet->cpu_load = cpu_load;
    packet->free_heap = free_heap;
    packet->log_good = log_good;
    packet->log_number = log_number;
    packet->main_board_state = main_board_state;
    packet->motor_board_state = motor_board_state;
    packet->main_can_status = main_can_status;
    packet->motor_can_status = motor_can_status;
    packet->rig_can_status = rig_can_status;
    packet->hil_state = hil_state;

    _mav_finalize_message_chan_send(chan, MAVLINK_MSG_ID_PAYLOAD_STATS_TM, (const char *)packet, MAVLINK_MSG_ID_PAYLOAD_STATS_TM_MIN_LEN, MAVLINK_MSG_ID_PAYLOAD_STATS_TM_LEN, MAVLINK_MSG_ID_PAYLOAD_STATS_TM_CRC);
#endif
}
#endif

#endif

// MESSAGE PAYLOAD_STATS_TM UNPACKING


/**
 * @brief Get field liftoff_max_acc_ts from payload_stats_tm message
 *
 * @return [us] System clock at the maximum liftoff acceleration
 */
static inline uint64_t mavlink_msg_payload_stats_tm_get_liftoff_max_acc_ts(const mavlink_message_t* msg)
{
    return _MAV_RETURN_uint64_t(msg,  0);
}

/**
 * @brief Get field liftoff_max_acc from payload_stats_tm message
 *
 * @return [m/s2] Maximum liftoff acceleration
 */
static inline float mavlink_msg_payload_stats_tm_get_liftoff_max_acc(const mavlink_message_t* msg)
{
    return _MAV_RETURN_float(msg,  32);
}

/**
 * @brief Get field dpl_ts from payload_stats_tm message
 *
 * @return [us] System clock at drouge deployment
 */
static inline uint64_t mavlink_msg_payload_stats_tm_get_dpl_ts(const mavlink_message_t* msg)
{
    return _MAV_RETURN_uint64_t(msg,  8);
}

/**
 * @brief Get field dpl_max_acc from payload_stats_tm message
 *
 * @return [m/s2] Max acceleration during drouge deployment
 */
static inline float mavlink_msg_payload_stats_tm_get_dpl_max_acc(const mavlink_message_t* msg)
{
    return _MAV_RETURN_float(msg,  36);
}

/**
 * @brief Get field max_z_speed_ts from payload_stats_tm message
 *
 * @return [us] System clock at max vertical speed
 */
static inline uint64_t mavlink_msg_payload_stats_tm_get_max_z_speed_ts(const mavlink_message_t* msg)
{
    return _MAV_RETURN_uint64_t(msg,  16);
}

/**
 * @brief Get field max_z_speed from payload_stats_tm message
 *
 * @return [m/s] Max measured vertical speed
 */
static inline float mavlink_msg_payload_stats_tm_get_max_z_speed(const mavlink_message_t* msg)
{
    return _MAV_RETURN_float(msg,  40);
}

/**
 * @brief Get field max_airspeed_pitot from payload_stats_tm message
 *
 * @return [m/s] Max speed read by the pitot tube
 */
static inline float mavlink_msg_payload_stats_tm_get_max_airspeed_pitot(const mavlink_message_t* msg)
{
    return _MAV_RETURN_float(msg,  44);
}

/**
 * @brief Get field max_speed_altitude from payload_stats_tm message
 *
 * @return [m] Altitude at max speed
 */
static inline float mavlink_msg_payload_stats_tm_get_max_speed_altitude(const mavlink_message_t* msg)
{
    return _MAV_RETURN_float(msg,  48);
}

/**
 * @brief Get field apogee_ts from payload_stats_tm message
 *
 * @return [us] System clock at apogee
 */
static inline uint64_t mavlink_msg_payload_stats_tm_get_apogee_ts(const mavlink_message_t* msg)
{
    return _MAV_RETURN_uint64_t(msg,  24);
}

/**
 * @brief Get field apogee_lat from payload_stats_tm message
 *
 * @return [deg] Apogee latitude
 */
static inline float mavlink_msg_payload_stats_tm_get_apogee_lat(const mavlink_message_t* msg)
{
    return _MAV_RETURN_float(msg,  52);
}

/**
 * @brief Get field apogee_lon from payload_stats_tm message
 *
 * @return [deg] Apogee longitude
 */
static inline float mavlink_msg_payload_stats_tm_get_apogee_lon(const mavlink_message_t* msg)
{
    return _MAV_RETURN_float(msg,  56);
}

/**
 * @brief Get field apogee_alt from payload_stats_tm message
 *
 * @return [m] Apogee altitude
 */
static inline float mavlink_msg_payload_stats_tm_get_apogee_alt(const mavlink_message_t* msg)
{
    return _MAV_RETURN_float(msg,  60);
}

/**
 * @brief Get field min_pressure from payload_stats_tm message
 *
 * @return [Pa] Apogee pressure - Digital barometer
 */
static inline float mavlink_msg_payload_stats_tm_get_min_pressure(const mavlink_message_t* msg)
{
    return _MAV_RETURN_float(msg,  64);
}

/**
 * @brief Get field cpu_load from payload_stats_tm message
 *
 * @return  CPU load in percentage
 */
static inline float mavlink_msg_payload_stats_tm_get_cpu_load(const mavlink_message_t* msg)
{
    return _MAV_RETURN_float(msg,  68);
}

/**
 * @brief Get field free_heap from payload_stats_tm message
 *
 * @return  Amount of available heap in memory
 */
static inline uint32_t mavlink_msg_payload_stats_tm_get_free_heap(const mavlink_message_t* msg)
{
    return _MAV_RETURN_uint32_t(msg,  72);
}

/**
 * @brief Get field log_number from payload_stats_tm message
 *
 * @return  Currently active log file, -1 if the logger is inactive
 */
static inline int16_t mavlink_msg_payload_stats_tm_get_log_number(const mavlink_message_t* msg)
{
    return _MAV_RETURN_int16_t(msg,  80);
}

/**
 * @brief Get field log_good from payload_stats_tm message
 *
 * @return  0 if log failed, 1 otherwise
 */
static inline int32_t mavlink_msg_payload_stats_tm_get_log_good(const mavlink_message_t* msg)
{
    return _MAV_RETURN_int32_t(msg,  76);
}

/**
 * @brief Get field main_board_state from payload_stats_tm message
 *
 * @return  Main board fmm state
 */
static inline uint8_t mavlink_msg_payload_stats_tm_get_main_board_state(const mavlink_message_t* msg)
{
    return _MAV_RETURN_uint8_t(msg,  82);
}

/**
 * @brief Get field motor_board_state from payload_stats_tm message
 *
 * @return  Motor board fmm state
 */
static inline uint8_t mavlink_msg_payload_stats_tm_get_motor_board_state(const mavlink_message_t* msg)
{
    return _MAV_RETURN_uint8_t(msg,  83);
}

/**
 * @brief Get field main_can_status from payload_stats_tm message
 *
 * @return  Main CAN status
 */
static inline uint8_t mavlink_msg_payload_stats_tm_get_main_can_status(const mavlink_message_t* msg)
{
    return _MAV_RETURN_uint8_t(msg,  84);
}

/**
 * @brief Get field motor_can_status from payload_stats_tm message
 *
 * @return  Motor CAN status
 */
static inline uint8_t mavlink_msg_payload_stats_tm_get_motor_can_status(const mavlink_message_t* msg)
{
    return _MAV_RETURN_uint8_t(msg,  85);
}

/**
 * @brief Get field rig_can_status from payload_stats_tm message
 *
 * @return  RIG CAN status
 */
static inline uint8_t mavlink_msg_payload_stats_tm_get_rig_can_status(const mavlink_message_t* msg)
{
    return _MAV_RETURN_uint8_t(msg,  86);
}

/**
 * @brief Get field hil_state from payload_stats_tm message
 *
 * @return  1 if the board is currently in HIL mode
 */
static inline uint8_t mavlink_msg_payload_stats_tm_get_hil_state(const mavlink_message_t* msg)
{
    return _MAV_RETURN_uint8_t(msg,  87);
}

/**
 * @brief Decode a payload_stats_tm message into a struct
 *
 * @param msg The message to decode
 * @param payload_stats_tm C-struct to decode the message contents into
 */
static inline void mavlink_msg_payload_stats_tm_decode(const mavlink_message_t* msg, mavlink_payload_stats_tm_t* payload_stats_tm)
{
#if MAVLINK_NEED_BYTE_SWAP || !MAVLINK_ALIGNED_FIELDS
    payload_stats_tm->liftoff_max_acc_ts = mavlink_msg_payload_stats_tm_get_liftoff_max_acc_ts(msg);
    payload_stats_tm->dpl_ts = mavlink_msg_payload_stats_tm_get_dpl_ts(msg);
    payload_stats_tm->max_z_speed_ts = mavlink_msg_payload_stats_tm_get_max_z_speed_ts(msg);
    payload_stats_tm->apogee_ts = mavlink_msg_payload_stats_tm_get_apogee_ts(msg);
    payload_stats_tm->liftoff_max_acc = mavlink_msg_payload_stats_tm_get_liftoff_max_acc(msg);
    payload_stats_tm->dpl_max_acc = mavlink_msg_payload_stats_tm_get_dpl_max_acc(msg);
    payload_stats_tm->max_z_speed = mavlink_msg_payload_stats_tm_get_max_z_speed(msg);
    payload_stats_tm->max_airspeed_pitot = mavlink_msg_payload_stats_tm_get_max_airspeed_pitot(msg);
    payload_stats_tm->max_speed_altitude = mavlink_msg_payload_stats_tm_get_max_speed_altitude(msg);
    payload_stats_tm->apogee_lat = mavlink_msg_payload_stats_tm_get_apogee_lat(msg);
    payload_stats_tm->apogee_lon = mavlink_msg_payload_stats_tm_get_apogee_lon(msg);
    payload_stats_tm->apogee_alt = mavlink_msg_payload_stats_tm_get_apogee_alt(msg);
    payload_stats_tm->min_pressure = mavlink_msg_payload_stats_tm_get_min_pressure(msg);
    payload_stats_tm->cpu_load = mavlink_msg_payload_stats_tm_get_cpu_load(msg);
    payload_stats_tm->free_heap = mavlink_msg_payload_stats_tm_get_free_heap(msg);
    payload_stats_tm->log_good = mavlink_msg_payload_stats_tm_get_log_good(msg);
    payload_stats_tm->log_number = mavlink_msg_payload_stats_tm_get_log_number(msg);
    payload_stats_tm->main_board_state = mavlink_msg_payload_stats_tm_get_main_board_state(msg);
    payload_stats_tm->motor_board_state = mavlink_msg_payload_stats_tm_get_motor_board_state(msg);
    payload_stats_tm->main_can_status = mavlink_msg_payload_stats_tm_get_main_can_status(msg);
    payload_stats_tm->motor_can_status = mavlink_msg_payload_stats_tm_get_motor_can_status(msg);
    payload_stats_tm->rig_can_status = mavlink_msg_payload_stats_tm_get_rig_can_status(msg);
    payload_stats_tm->hil_state = mavlink_msg_payload_stats_tm_get_hil_state(msg);
#else
        uint8_t len = msg->len < MAVLINK_MSG_ID_PAYLOAD_STATS_TM_LEN? msg->len : MAVLINK_MSG_ID_PAYLOAD_STATS_TM_LEN;
        memset(payload_stats_tm, 0, MAVLINK_MSG_ID_PAYLOAD_STATS_TM_LEN);
    memcpy(payload_stats_tm, _MAV_PAYLOAD(msg), len);
#endif
}
